echo '=== Missing required symbols:'
echo -n "$MISSING" | grep -v '|optional=' || true
echo '=== New symbols:'
- grep '^+ ' "$1" | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
+ grep '^+ ' "$1" | grep -v '^+ (c++' | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
echo " (c++)\"${line}@${SYMVER}\" $VERSION"
done | sort -u
}
sed -i -e "s/^PACKAGE_VERSION=\".*\"$/PACKAGE_VERSION=\"${VERSION}\"/" configure.ac
sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
+ # update the last-modification field of manpages based on git changes
+ grep --files-with-matches '<date>' doc/*.xml | while read file; do \
+ LASTMOD="$(date -d "@$(git log --format='%at' --max-count=1 --invert-grep --fixed-strings --grep 'review
+typo
+release
+Git-Dch: Ignore' "$file")" '+%Y-%m-%dT00:00:00Z')"
+ sed -i -e "s#^\([ ]\+\)<date>.*</date>\$#\1<date>$LASTMOD</date>#" "$file"
+ done
+
if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
"$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
make update-po
fi
+elif [ "$1" = 'pre-build' ]; then
+ if [ "$DISTRIBUTION" = "UNRELEASED" ]; then
+ echo 'BUILDING AN UNRELEASED VERSION'
+ else
+ CONFVERSION="$(sed -ne "s/^PACKAGE_VERSION=\"\(.*\)\"$/\1/p" configure.ac)"
+ if [ "$VERSION" != "$CONFVERSION" ]; then
+ echo "changelog (${VERSION}) and configure (${CONFVERSION}) talk about different versions!"
+ echo "You probably want to run »./prepare-release pre-export« to fix this."
+ exit 1
+ fi
+ fi
elif [ "$1" = 'post-build' ]; then
if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
- echo >&2 "REMEMBER: Tag this release with »git tag ${VERSION}« if you are satisfied"
+ echo >&2 "REMEMBER: Tag this release with »git tag -s ${VERSION}« if you are satisfied"
else
echo >&2 'REMEMBER: Change to a valid distribution before release'
fi
elif [ "$1" = 'library' ]; then
librarysymbols() {
- echo "Checking $1 in version $2"
+ local libname=$(echo "${1}" | cut -c 4-)
+ local buildlib="build/bin/${1}.so.${2}"
+ for dir in $libname */$libname; do
+ local new_buildlib="$dir/${1}.so.${2}"
+ if [ -r "${new_buildlib}" ] && [ ! -e "$buildlib" -o "$new_buildlib" -nt "$buildlib" ]; then
+ local buildlib="${new_buildlib}"
+ fi
+ done
+ if [ ! -r "$buildlib" ]; then
+ echo "ERROR: The library ${1} has to be built before symbols can be checked!"
+ return
+ fi
+ echo "Checking $1 in version $2 build at $(stat -L -c '%y' "$buildlib")"
local tmpfile=$(mktemp)
- dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
+ dpkg-gensymbols -p${1}${2} -e${buildlib} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_${2}"
rm -f $tmpfile
}
shift
done
elif [ "$1" = 'travis-ci' ]; then
- apt-get install -q --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' | tr -d ',')
- apt-get install -q --no-install-recommends $(sed -n 's#^Depends: .*@, \(.*\)$#\1#p' debian/tests/control | tr -d ',')
+ apt-get install -qy --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' -e 's#<.*>##g' | tr -d ',')
+ apt-get install -qy --no-install-recommends $(sed -n 's#^Depends: .*@, \(.*\)$#\1#p' debian/tests/control | tr -d ',')
elif [ "$1" = 'coverage' ]; then
DIR="${2:-./coverage}"
git clean -dfX # remove ignored build artefacts for a clean start
genhtml --output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
else
echo >&1 "Usage:\t$0 pre-export
+\t$0 pre-build
\t$0 post-build
-If you use »git buildpackage« you can leave these alone as they will
-be run at the right places auto-magically. Otherwise you should use
-»pre-export« to update po and pot files as well as version numbering.
-»post-build« can be used to run some more or less useful checks later on.
+Updating po-files and versions as well as some basic checks are done
+by »pre-export« which needs to be run before package building.
+If you use »gbp buildpackage« you will be notified if you forget.
+»pre-build« and »post-build« can be used to run some more or less
+useful checks automatically run by »gbp« otherwise.
\t$0 library
\t$0 buildlog filename…